$ ->
  # create collection popover
  $('#create_collection_popover').popover
    html: true
    content: ->
      $('#create_collection_popover_content').html()
    title: ->
      $('#create_collection_popover_title').html()
  return

# add/remove learning object to collection
$(document).on 'click', '.add-to-collection', ->
  $(document).trigger('open_collections_modal', [learning_object: [$(this).data('loid')], type: 'add'])

# change collection privacy
$(document).on 'click', 'input[name=privacy]', ->
  url = '/collections/' + encodeURIComponent($(this).data('cid')) + '/change_privacy'
  value = $('input[name=privacy]:checked').val()
  $.post url, {'privacy':value}, (d) ->
    d

$(document).on 'open_collections_modal', (evt, params) ->
  id = if (params.collection == undefined) then "all" else encodeURIComponent(params.collection)
  url = '/collections/' + id + '/list?type=' + params.type
  url += '&learning_objects_ids=' + encodeURIComponent(params.learning_object) if params.learning_object != undefined
  $.get url, (d) ->
    $('#collections-modal').remove()
    $('body').append d
    $('#collections-modal').modal('show')
    return

mount_modal_params = (e) ->
  array = $(e).serializeArray()
  object = {}
  collection = ""
  type = ""
  collections = []
  learning_objects = []

  i = 0
  length = array.length
  while i < length
    switch array[i].name
      when 'collection' then collections.push(array[i].value)
      when 'learning_object' then learning_objects.push(array[i].value)
      when 'collection_id' then collection = array[i].value
      when 'type' then type = array[i].value
    ++i

  object.collection_id = collection
  object.collections_ids = collections if collections.length > 0
  object.learning_objects_ids = learning_objects if learning_objects.length > 0
  object.type = type
  return object

$(document).on 'submit', '#collections-modal-form', (evt, params) ->
  evt.preventDefault()
  data = mount_modal_params(this)

  return false if (data.learning_objects_ids.length < 1) || (data.collections_ids.length < 1) || (permitted_types.indexOf(data.type) < 0)

  id = if (data.collections_ids == undefined) then data.collection_id else data.collections_ids
  url = '/collections/' + encodeURIComponent(id) + '/learning_objects/' + encodeURIComponent(data.learning_objects_ids.join())
  $.ajax {method: "POST", url: url, data: data }
  .done () ->
    if (data.type == "move")
      url = '/collections/' + encodeURIComponent(data.collection_id) + '/learning_objects/' + encodeURIComponent(data.learning_objects_ids.join())
      $.ajax {method: "DELETE", url: url, data: data }
      .done ->
        $(document).trigger('refresh_comments')
    $(document).trigger 'flash_notice', {text: 'Operação efetuada com sucesso!', type: 'notice'}
    $(document).trigger('clear_collections')
    $('#collections-modal').modal('hide')
  return

# manipulate collections
# $(document).on 'ready page:load', ->
#   if $('.collection-show-page').val() != undefined
# array with selected objects ids
selected_objects = []
$ ->
  selected_objects = []
# valid types of operations in collections
permitted_types = ['add', 'download', 'copy', 'move', 'remove']

$(document).on 'ready page:load', ->
  if $('.collection-show-page').val() != undefined
    $(document).trigger('add_collection_selector')

# add selectors to learning objects
$(document).on 'add_collection_selector', (e) ->
  $('.learning-object-vertical').each (e) ->
    loid = $(this).data('loid')
    $('.learning-object-thumbnail', this).append '<input class="collection-selector" type="checkbox" value="' + loid + '"></input>'
    return

# add/remove object to array when click checkbox
$(document).on 'click', '.collection-selector', ->
  if this.checked
    if selected_objects.indexOf(this.value) < 0
      selected_objects.push this.value
      $(document).trigger('check_selected_collection')
    return
  else
    index = selected_objects.indexOf(this.value)
    if !!(~index)
      selected_objects.splice(index, 1)
      $(document).trigger('check_selected_collection')
    return

# select all objects
$(document).on 'mark_all_collections', ->
  selected_objects = []
  $('.collection-selector').each () ->
    $(this).attr('checked', true) if !this.checked
    selected_objects.push this.value
  $(document).trigger('check_selected_collection')

$(document).on 'click', '.count-collections-objects', ->
  $(document).trigger('mark_all_collections')

# clear selected objects
$(document).on 'clear_collections', ->
  selected_objects = []
  $('.collection-selector').attr('checked', false)
  $(document).trigger('check_selected_collection')

$(document).on 'click', '.collection-show-select-nav .navbar-brand', ->
  $(document).trigger('clear_collections')

# manipulation buttons
$(document).on 'click', '.collection-button', ->
  collection = $('.collection-show-page').data('cid')
  index = permitted_types.indexOf($(this).data('action'))
  if permitted_types[index] == 'remove'
    url = '/collections/' + encodeURIComponent(collection) + '/learning_objects/' + encodeURIComponent(selected_objects.join())
    if confirm('Você tem certeza?')
      $.ajax { method: 'DELETE', url: url }
      .done ->
        $(document).trigger 'refresh_comments'
  else
    $(document).trigger('open_collections_modal', [collection: collection, type: permitted_types[index], learning_object: selected_objects ]) if !!(~index)

# refresh comments via ajax
$(document).on 'refresh_comments', (e) ->
  selected_objects = []
  $(document).trigger 'check_selected_collection'

  $parent = $('.learning-object-columns')
  url = window.location.pathname + '?list=true'
  $parent.html('Carregando...')

  $.get url, (data) ->
    $parent.html('<br>' + data)
    $(document).trigger 'create-learning-object-columns'
    $(document).trigger 'add_collection_selector'

# update interface when add/remove an object
$(document).on 'check_selected_collection', (e) ->
  length = selected_objects.length
  if length == 0
    return $('.collection-show-select-nav').slideUp('slow')
  else if (length == 1)
    html = "1 objeto selecionado"
  else
    html = length + " objetos selecionados"
  $('.collection-show-select-nav .navbar-brand').html html
  $('.collection-show-select-nav').slideDown('slow')
