class ComplaintBuilder < Builder
  extend RepositoriesProxy

  ##
  # receive a list of ids and return a list of complaints
  #
  def self.build(complaints = [])
    array = []
    complaints = [complaints] if complaints.class == String
    complaints.each do |complaint|
      rid = complaint['@rid'] || complaint['rid']
      unless rid.blank?
        o = complaint_repository.find complaint['@rid'] #if o.nil?
        array << o
      end
    end
    array
  end

  def self.build_from_orientdb(args = {})
    unless args.nil?
      created = DateTime.now.strftime("%Y-%m-%d %H:%M:%S")
      created = DateTime.strptime(args['created_at'], "%Y-%m-%d %H:%M:%S") unless args['created_at'].blank?

      Complaint.new(
          id: args['@rid'],
          user: user_repository.get_by_rid(args['out']),
          created_at: created,
          object: learning_object_repository.find(args['in'].to_s),
          message: ComplaintMessage.new(args['message']),
          description: args['description'] || ''
      )
    end
  end

end
