class ComplaintsController < ApplicationController
  before_action :authenticate_user!
  include RepositoriesProxy

  def create
    @complaint = Complaint.new(complaint_params)
    @complaint.user = current_user

    respond_to do |format|
      if complaint_repository.report @complaint
        format.html { redirect_to :back, notice: 'Denúncia realizada com sucesso.' }
      else
        format.html { redirect_to :back, alert: 'Objeto já foi denunciado por você.' }
      end
    end
  end

  private

  # Never trust parameters from the scary internet, only allow the white list through.
  def complaint_params
    params.require(:complaint).permit(:object, :message, :description)
  end
end
