module OrientDb
  class RelationChain
    attr_reader :object, :connection

    def initialize(object, connection)
      @object = object
      @connection = connection
    end

    def create
      relations.each { |relation| relation.create }
    end

    def relations
      raise NotImplementedError, 'RelationChain#relations is an abstract method.'
    end

  end
end