class Ranking::Strategies::BasicRater < Ranking::Strategy

  def sortByRate(items)
    items.zip( items.size.downto(1) )
        .collect { |item,reverseIndex| rateItem( item, reverseIndex ) }
        .sort { |itemA,itemB| itemA.rate <=> itemB.rate }
        .collect { |ri| ri.item }
        .reverse # Best ranked comes first
  end

  private

  def rateItem(item, inversePosition)
    positionRating = inversePosition * @positionWeight
    useRating = (item.downloads < item.views ? item.downloads : item.views) * @useWeight
    likeRating = item.likes * @likeWeight

    rate = positionRating + useRating + likeRating
    build_rated_item item, rate
  end

end
