# The repository class works as a storage of many models repositories
#
# Example:
# production_repository = Repository.new
# production_repository.register :user, Repositories::OrientDB::UserRepository.new
# production_repository.for(:user).create!(name: 'mauricio', email: 'mgg12@inf.ufpr.br')
class Repository::Repository

  def register(type, repository)
    repositories[type] = repository
  end

  def unregister(type)
    repositories.delete type
  end

  def repositories
    @repositories ||= {}
  end

  def for(type)
    repositories[type]
  end

end