require 'test_helper'

class LearningObjectTest < ActiveSupport::TestCase
  should validate_presence_of(:name)
  should validate_presence_of(:created_at)
  should validate_presence_of(:type)

  test 'serialize for orientdb' do
    learning_object = LearningObject.new(
        id: '#15:23',
        name: 'Teste',
        description: 'teste de serialização',
        thumbnail: '/asdasdasd.jpg',
        id_dspace: '123213',
        type: 'image',
        attachment: LearningObject::Attachment.new('[{"id":2203,"name":"Pontociencia_Efe_chamas_na_horizontal.flv","type":"bitstream","link":"/rest/bitstreams/2203","bundleName":"ORIGINAL","description":null,"format":"Unknown","mimeType":"application/octet-stream","sizeBytes":4108209,"parentObject":null,"retrieveLink":"/bitstreams/2203/retrieve","checkSum":{"value":"43bd43bea944dcb8708d6ec708fb510d","checkSumAlgorithm":"MD5"},"sequenceId":-1,"policies":null,"expand":["parent","policies","all"]}]'),
        last_modified: '2015-03-10 15:33:45',
        metadata: []
    )

    expected_hash = {"@class" => "LearningObject", "score" => 0, "name" => "Teste", "description" => "teste de serialização", "thumbnail" => "/asdasdasd.jpg", "id_dspace" => "123213", "type" => "image", "last_modified" => "2015-03-10 15:33:45", "metadata" => [], "bitstreams" => "[{\"id\":2203,\"name\":\"Pontociencia_Efe_chamas_na_horizontal.flv\",\"type\":\"bitstream\",\"link\":\"/rest/bitstreams/2203\",\"bundleName\":\"ORIGINAL\",\"description\":null,\"format\":\"Unknown\",\"mimeType\":\"application/octet-stream\",\"sizeBytes\":4108209,\"parentObject\":null,\"retrieveLink\":\"/bitstreams/2203/retrieve\",\"checkSum\":{\"value\":\"43bd43bea944dcb8708d6ec708fb510d\",\"checkSumAlgorithm\":\"MD5\"},\"sequenceId\":-1,\"policies\":null,\"expand\":[\"parent\",\"policies\",\"all\"]}]"}
    assert_equal(expected_hash, learning_object.to_orientdb_hash)
  end

end
